/*
  	#[ Include file :
*/
#include "stedi.h"
/*
  	#] Include file : 
  	#[ Words :
 		#[ Next Word :
*/

LONG
wordnx(VOID)
{
	BUFFER b = cbuf;
	LINE l;
	WORD type, n;
	LONG number;
	WORD num;
	UBYTE *address;
	FINDPOS fp;
	if ( commandmode ) b = commandbuffer;
	l = b->current;
	type = FindChar(l,b->column,&fp);
	address = fp.address; num = fp.num;
	n = LENGTH(l);
	n -= num;
	if ( ( type == NORMALCHAR ) || ( type == ONTAB ) ) {
		if ( ( n >= 0 ) && ( dbufFer.wordtable[*address] == 0 ) )
			{ address++; n--; num++; type = ONTAB; }
	}
 	switch ( type ) {
		case NORMALCHAR :
			while ( ( n >= 0 ) && ( dbufFer.wordtable[*address] > 0 ) ) {
				n--; address++; num++;
			}
		case ONTAB :
		case INSIDETAB :
			if ( n >= 0 ) {
				while ( ( n >= 0 ) && ( dbufFer.wordtable[*address] < 0 ) ) {
					n--; address++; num++;
				}
				if ( n >= 0 ) {
					b->column = FindColumn(l,num);
					b->newvirt = 0;
					if ( commandmode ) MessageCommand();
					else DoDisplay();
					return(0L);
				}
			}
	}
	if ( commandmode ) return(0L);
	number = b->newline;
	if ( l->used < 0 ) number += LINESINFOLD(l);
	else number++;
	while ( ( l = l->next ) != (LINE)b ) {
		n = l->used - LINEHEAD;
		if ( n < 0 ) {
			n = ((FOLDLINE)l)->used - FOLDHEAD;
			address = ((FOLDLINE)l)->text;
		}
		else { address = l->text; }
		num = 1;
		if ( n > 0 ) {
			while ( ( n > 0 ) && ( dbufFer.wordtable[*address] < 0 ) ) {
				n--; address++; num++;
			}
			if ( n > 0 ) {
				b->column = FindColumn(l,num);
				b->newvirt = 0;
				b->current = l;
				b->newline = number;
				DoDisplay();
				return(0L);
			}
		}
		if ( l->used < 0 ) number += LINESINFOLD(l);
		else number++;
	}
	MesnOut(87); /* "No more words." */
	return(-2L);
}

/*
 		#] Next Word : 
 		#[ Previous Word :
*/

LONG
wordpr(VOID)
{
	BUFFER b = cbuf;
	LINE l;
	WORD type, n;
	LONG number;
	WORD num;
	UBYTE *address;
	FINDPOS fp;
	if ( commandmode ) b = commandbuffer;
	l = b->current;
	if ( b->newvirt > 0 ) {
		if ( l == (LINE)b ) return(0L);
		number = b->newline + 1;
		goto InPrevLoop;
	}
	type = FindChar(l,b->column,&fp);
	address = fp.address; num = fp.num;
	if ( ( type == NORMALCHAR ) || ( type == ONTAB ) ) {
		if ( ( num > 0 ) && ( dbufFer.wordtable[*address] == 0 ) )
			{ address--; num--; type = ONTAB; }
	}
	if ( type == NORMALCHAR ) {
			while ( ( num > 0 ) && ( dbufFer.wordtable[*address] > 0 ) )
				{ num--; address--; }
	}
	if ( num > 0 ) {
		if ( ( type == AFTERVIRTUAL ) || ( type == NORMALEOL ) ) address--;
		while ( ( num > 0 ) && ( dbufFer.wordtable[*address] < 0 ) ) {
			num--; address--;
		}
		if ( num > 0 ) {
			b->column = FindColumn(l,num);
			b->newvirt = 0;
			if ( commandmode ) MessageCommand();
			else DoDisplay();
			return(0L);
		}
	}
	if ( commandmode ) return(0L);
	number = b->newline;
	while ( ( l = l->prev ) != (LINE)b ) {
InPrevLoop:
		if ( l->used < 0 ) number -= LINESINFOLD(l);
		else number--;
		n = l->used - LINEHEAD;
		if ( n < 0 ) {
			n = ((FOLDLINE)l)->used - FOLDHEAD;
			address = ((FOLDLINE)l)->text + n - 1;
		}
		else { address = l->text + n - 1; }
		if ( n > 0 ) {
			while ( ( n > 0 ) && ( dbufFer.wordtable[*address] < 0 ) ) {
				n--; address--;
			}
			if ( n > 0 ) {
				b->column = FindColumn(l,n);
				b->newvirt = 0;
				b->current = l;
				b->newline = number;
				DoDisplay();
				return(0L);
			}
		}
	}
	MesnOut(87); /* "No more words." */
	return(-2L);
}

/*
 		#] Previous Word : 
 		#[ Delete Word Forward :
*/

LONG
wordel(VOID)
{
	BUFFER b = cbuf;
	LINE l;
	WORD type, n = 0, m;
	UBYTE *s;
	LONG ret = 0;
	FINDPOS fp;
	if ( commandmode ) b = commandbuffer;
	l = b->current;
	if ( l->used < 0 ) return(NoFold());
	if ( b->newvirt > 0 ) return(0L);
	type = FindChar ( l, b->column, &fp);
	if ( ( type == AFTERVIRTUAL ) || ( type == NORMALEOL ) ) {
		if ( commandmode ) return(0L);
		if ( ( ret = Cdelete() ) < 0 ) return(ret);
		l = b->current;
		if ( l->used < 0 ) return(NoFold());
		if ( l->used == LINEHEAD ) return(0L);
		type = FindChar ( l, b->column, &fp);
		s = fp.address;
		m = l->used - LINEHEAD;
	}
	else {
		s = fp.address;
		m = l->used - LINEHEAD;
		if ( type == NORMALCHAR ) {
			if ( dbufFer.wordtable[*fp.address] > 0 ) {
				while ( ( fp.num <= m ) && ( dbufFer.wordtable[*s] > 0 ) ) {
					n++; s++; fp.num++;		/* skip word */
				}
			}
			else {	n++; s++; fp.num++; }
		}
		else {
			Cinsert((UBYTE *)(" "),1);
			b->column--;
			l = b->current;
			type = FindChar ( l, b->column, &fp);
			s = fp.address;
			m = l->used - LINEHEAD;
			n++; s++; fp.num++;
		}
	}
	while ( ( fp.num <= m ) && ( ( *s == ' ' ) || ( *s == '\t' ) ) ) {
		n++; s++; fp.num++;
	}
	if ( commandmode ) {
		while ( --n >= 0 ) Tdelete();
		MessageCommand();
		return(0L);
	}
	while ( --n >= 0 ) { if ( ( ret = Cdelete() ) < 0 ) break; }
	DoDisplay();
	return(ret);
}

/*
 		#] Delete Word Forward : 
 		#[ Delete Word Backward :
*/

LONG
wordlf(VOID)
{
	BUFFER b = cbuf;
	LINE l;
	WORD type, n = 0, num;
	UBYTE *s;
	LONG ret = 0;
	FINDPOS fp;
	if ( commandmode ) b = commandbuffer;
	l = b->current;
	if ( b->newvirt > 0 )	return(sh_hom());
	if ( l->used	< 0 )	return(NoFold());
	if ( b->column == 1 )	return(Bdelete());
	type = FindChar ( l, b->column-1, &fp );
	s = fp.address; num = fp.num;
	if ( type == NORMALCHAR ) {
		if ( num > 0 ) {
			if ( dbufFer.wordtable[*s] > 0 ) {
				while ( ( num > 0 ) && ( dbufFer.wordtable[*s] > 0 ) ) {
					n++; s--; num--;		/* skip word */
				}
			}
			else { n++; s--; num--; }
		}
	}
	else {
		if ( num > 0 ) { n++; s--; num--; }
		if ( type != ONTAB ) n += fp.virt;
	}
	while ( ( num > 0 ) && ( ( *s == ' ' ) || ( *s == '\t' ) ) ) {
		n++; s--; num--;
	}
	if ( commandmode ) {
		while ( ( --n >= 0 ) && ( b->column > 1 ) )
			{ l_arrow(); Tdelete(); }
		MessageCommand();
		return(0L);
	}
	num = b->iomode;
	b->iomode = INSERTMODE;
	while ( --n >= 0 ) { if ( ( ret = Bdelete() ) < 0 ) break; }
	b->iomode = num;
	DoDisplay();
	return(ret);
}

/*
 		#] Delete Word Backward : 
 		#[ Wordwrapping :
			#[ Wrap one line :
*/

LONG
WrapWord(LINE l,WORD col)
{
	BUFFER b = cbuf;
	WORD num, type, numc = 0, typec = 0, old1, old2;
	UBYTE *address;
	WORD w, numf = 0;
	LONG ret;
	FINDPOS fp, fpp;
	w = b->wordwrap;
	if ( w < 0 ) w = -w;
	type = FindChar(l,w,&fp);
	address = fp.address; num = fp.num;
	if ( type == AFTERVIRTUAL ) return(0L);		/* No wrap */
	if ( col > 0 ) {
		typec = FindChar(l,col,&fpp);
		numc = l->used - LINEHEAD - fpp.num;
		/* numc if the number of chars after the current column */
	}
	if ( *address != ' ' || b->wordwrap < 0 ) {
		address--;
		if ( type == NORMALEOL ) num--;
		while ( ( num > 0 ) && ( *address != ' ' ) && ( *address != '\t' )
		&& ( *address != ',' ) ) {
			address--; num--; numf++;
		}
	}
	else num++;
	old1 = b->autoindent;
	if ( b->wordwrap < 0 ) {
	 	if ( old1 > 0 ) b->autoindent = 9;	/* Fortran wrap */
		else if ( old1 == 0 ) {
			if ( b->tabstring[0] >= 7 )
				b->autoindent = -((WORD)(b->tabstring[0])) - 2;
			else b->autoindent = -9;
		}
		else {
			if ( old1 > -9 ) b->autoindent = -9;
		}
	}
	old2 = b->column;
	if ( ( b->wordwrap < 0 ) && ( numf > 10 ) ) { b->column = w; numf = 0; }
	else b->column = FindColumn(l,num);
	UpdateDisplay();
	if ( ( ret = CRnorm() ) < 0 ) {
		b->autoindent = old1;
		b->column = old2;
		return(ret);
	}
	b->autoindent = old1;
	if ( b->wordwrap < 0 ) {
		b->column = 6;
		old1 = b->iomode;
		b->iomode = 1;		/* Put in overstrike mode */
		ret = InNorm((UBYTE *)("+"),1);
		b->iomode = old1;
	}
	if ( col > 0 ) {
		numc = b->current->used - LINEHEAD - numc;
		if ( ( typec == NORMALCHAR ) || ( typec == ONTAB ) )
			b->column = FindColumn(b->current,numc);
		else if ( typec == INSIDETAB ) {
			if ( numc > 1 )
				b->column = FindColumn(b->current,numc-1) + 1 + fpp.virt;
			else b->column = 1 + fpp.virt;
		}
		else {
			if ( b->newvirt ) b->column = 1;
			else {
				b->column = FindColumn(b->current,numc) + 1 + fpp.virt;
				if ( numc == 0 ) b->column--;
			}
		}
		DoDisplay();
	}
	return(0L);
}

/*
			#] Wrap one line : 
			#[ Rcleanup :			WORD Rcleanup(line,par)

	Routine to clean up a line. This means that after the last tab all
	unnecessary blanks should be removed.

	This routine must be called with care.
	The allocation could be altered when par != 0.
	It should then be called with:
	if ( Rcleanup(line->next,1) < 0 ) {No memory action}
	line = line->next.

	This avoids all problems.
*/

#ifdef WITHOUTLINE

#ifdef ANSI
WORD TestLine(LINE line);
WORD FindParagraph(BUFFER buf,LINE line,LINE *start,LINE *end);
LINE Radjust(LINE line);
WORD Rcleanup(LINE line,WORD par);
#else
WORD TestLine();
WORD FindParagraph();
LINE Radjust();
WORD Rcleanup();
#endif

WORD
Rcleanup(LINE line,WORD par)
{
	WORD n;
	UBYTE *s, *t, *u;
	if ( ( n = line->used - LINEHEAD ) < 0 ) return(0);	/* Fold line */
	s = line->text + n;
	while ( s >= line->text ) {
		s--;
		if ( *s != ' ' && *s != '\t' ) break;
	}
	t = s+1;
	while ( s >= line->text ) {
		if ( *--s == '\t' ) { s++; break; }
	}
	while ( s < t && *s == ' ' ) s++;
	u = s;
	while ( s < t ) {
		if ( ( *u++ = *s++ ) == ' ' ) {
			while ( s < t && *s == ' ' ) s++;
		}
	}
	n = (WORD)(line->used - (u-line->text)) - LINEHEAD;
	if ( par ) {
		if ( n > 0 ) { n--; *u++ = ' '; }
		else {
			n = (WORD)(u - (UBYTE *)line);
			if ( n < line->totlen ) {
				*u++ = ' '; line->used = n + 1;
			}
			else {
				LINE lnew;
				n -= LINEHEAD;
				lnew = LineAlloc(n+1,line);
				if ( lnew == 0 ) return(-1);
				u = lnew->text; s = line->text;
				while ( --n >= 0 ) *u++ = *s++;
				*u = ' ';
				LineDealloc(line);
			}
			return(1);
		}
	}
	DropPart(line,(WORD)(line->used-(u-line->text))-LINEHEAD);
	return(1);
}

/*
			#] Rcleanup : 
			#[ Radjust :			LINE Radjust(line);

	Routine for giving a line a nice right side adjustment. We consider 
	the range from the last tab to the wordwrap position. It is assumed
	that Rcleanup has been called first and that it isn't a foldline.
*/

static WORD direction = 0;

LINE
Radjust(LINE line)
{
	UBYTE *s, *t, *from, *to;
	WORD n, col, size, nsep, ndot, nbla, nper, iperiod, iblanks;
	UBYTE buffer[MAXINLINE];
	n = line->used - LINEHEAD;
	if ( n <= 0 ) return(line);
	to = line->text + n;
	s = to - 1;
	while ( s >= line->text ) {
		if ( *s == '\t' ) { s++; break; }
		s--;
	}
	if ( s < line->text ) s++;
	while ( s < to && *s == ' ' ) s++;
	from = s;
	if ( s == line->text ) col = 1;
	else col = FindColumn(line,(WORD)(s - line->text)) + 1;
	size = cbuf->wordwrap - col;
	if ( size < (to-from) ) return(0);
/*
	Count the number of words and the number of periods (they get one 
	extra blank if possible).
*/
	nsep = 0;
	ndot = 0;
	while ( s < to ) {
		if ( *s == ' ' ) nsep++;
		if ( ( *s == '.' || *s == ',' ) && (s+1) < to && s[1] == ' ' ) ndot++;
		s++;
	}
	nbla = size - (WORD)(to - from);
	if ( nbla > ndot ) nper = ndot;
	else nper = nbla;
	nbla -= nper; 
/*
	We have now nsep separations and ndot periods.
	There must be nbla extra blanks distributed over them.
	If the ratio is too lopsided we should abandon the project
*/
	if ( nsep == 0 || ( nbla-ndot ) > 3*nsep ) return(0);
	if ( nbla + line->used > MAXINLINE + LINEHEAD ) return(0);
/*
	We alternate coming from the left or coming from the right.
	This could avoid nasty white bands through the text.
	It may seem to make things nondeterministic.
*/
	direction ^= 1;
	t = buffer;
	iperiod = 0;
	iblanks = 0;
	if ( direction == 0 ) {
		s = from;
		while ( s < to ) {
			if ( ( *s == '.' || *s == ',' ) && (s+1) < to && s[1] == ' ' ) {
				*t++ = *s++;
				iperiod += nper;
				if ( iperiod >= ndot ) {
					*t++ = ' '; iperiod -= ndot;
				}
			}
			else if ( *s == ' ' ) {
				*t++ = *s++;
				iblanks += nbla;
				while ( iblanks >= nsep ) {
					*t++ = ' '; iblanks -= nsep;
				}
			}
			else *t++ = *s++;
		}
	}
	else {
		s = to;
		while ( s > from ) {
			s--;
			if ( ( *s == '.' || *s == ',' ) && (s+1) < to && s[1] == ' ' ) {
				iperiod += nper;
				if ( iperiod >= ndot ) {
					*t++ = ' '; iperiod -= ndot;
				}
				*t++ = *s;
			}
			else if ( *s == ' ' ) {
				iblanks += nbla;
				while ( iblanks >= nsep ) {
					*t++ = ' '; iblanks -= nsep;
				}
				*t++ = *s;
			}
			else *t++ = *s;
		}
	}
	n = (WORD)(t - buffer) + (WORD)(from - line->text);
	if ( (n + LINEHEAD) > line->totlen ) {
		LINE l;
		if ( ( l = LineAlloc(n,line) ) == 0 ) return(0);
		s = line->text;
		to = l->text;
		while ( s < from ) *to++ = *s++;
		LineDealloc(line);
		line = l;
	}
	else {
		line->used = n + LINEHEAD;
		to = from;
	}
	if ( direction == 0 ) {
		s = buffer;
		while ( s < t ) *to++ = *s++;
	}
	else {
		while ( t > buffer ) *to++ = *--t;
	}
	return(line);
}
 
/*
			#] Radjust : 
			#[ FindParagraph :		WORD FindParagraph(buf,line,start,end)

	We need a routine to mark a paragraph.
	The algorithm for determining what is a paragraph isn't trivial.
	Here we determine that a paragraph should be enclosed by lines
	that contain only whitespace, or are foldlines or potential foldlines.

	The variable buf allows us also to look inside a closed fold if needed.
*/

WORD
FindParagraph(BUFFER buf,LINE line,LINE *start,LINE *end)
{
	if ( line == (LINE)buf || line->used < 0 ) return(0);
	if ( TestLine(line) ) return(0);
	*start = *end = line;
	while ( (*start)->prev != (LINE)buf && TestLine((*start)->prev) == 0 )
		*start = (*start)->prev;
	while ( (*end)->next != (LINE)buf && TestLine((*end)->next) == 0 )
		*end = (*end)->next;
	return(1);
}
 
/*
			#] FindParagraph : 
			#[ TestLine :			WORD TestLine(line)
*/

WORD
TestLine(LINE line)
{
	UBYTE *s;
	WORD i, n = line->used - LINEHEAD;
	if ( n <= 0 ) return(1);
	s = line->text;
	i = n;
#ifdef DON1
	x = *s >> 3;
	y = *s & 7;
	y = 1 << y;
	if ( ( dbufFer.bitarray[x] & y ) != 0 ) return(1);
#endif
	do { if ( *s != ' ' && *s != '\t' ) break; s++; } while ( --i > 0 );
	if ( i <= 0 ) return(1);
	if ( n < 6 ) return(0);
	n -= 5;
	s = line->text + 5;
	if ( s[-2] != '#' || ( s[-1] != '[' && s[-1] != ']' ) ) return(0);
	do {
		if ( *s++ == ':' ) return(1);
	} while ( --n > 0 );
	return(0);
}
 
/*
			#] TestLine : 
			#[ outline :			LONG outline()

	Rewrapping of a paragraph:
	1:	Find the paragraph
	2:	Rcleanup(....,1) for each line
	3:	Use ReWrap
	4:	Rcleanup(....,0) for each line
	5:	Radjust for each line
*/

LONG
outline(VOID)
{
	BUFFER b = cbuf;
	LINE l, start, end;
	WORD ww, oldcolumn;
	LONG number, ret;
	if ( commandmode ) return(0L);
	if ( b->newvirt > 0 ) return(0L);
	if ( b->wordwrap <=0 ) {
		if ( b->wordwrap == 0 ) {
			MesnOut(88); /* "No wordwrap set." */
		}
		else {
			MesnOut(89); /* "No rewrapping in fortran mode." */
		}
		return(0L);
	}
	{
		LINE lstart, lend;
		if ( !FindParagraph(b,b->current,&lstart,&lend) ) return(0L);
		start = lstart; end = lend;
	}
	ClearUndo();
	l = b->current;
	number = b->newline;
	while ( l != start ) { number--; l = l->prev; }
	start = l = l->prev;
	end = end->next;
	do {
		Rcleanup(l->next,1);
		l = l->next;
	} while ( l->next != end );

	b->current = l = start->next;
	b->newline = number;
	UpdateDisplay();
/*
 *	1 : goto end of line; while ( column > wrapcolumn ) wrap
 *	2 : If next line in paragraph -> delete eol, else stop.
 *	3 : goto 1
 */
	ww = b->wordwrap;
	redraw++;
	ret = 0;
	do {
		ToEOL(); UpdateDisplay();
		while ( b->column > ww ) {
			oldcolumn = b->column;
			if ( ( ret = WrapWord(b->current,-1) ) < 0 ) goto EndWrap;
			ToEOL(); UpdateDisplay();
			if ( oldcolumn <= b->column ) {
/*
				Here should come some hyphenation code.
*/
				MesnOut(90); /* "Too long word for autorewrap." */
				goto EndWrap;
			}
		}
	} while ( b->current->next != end && ( ret = wordel() ) >= 0 );
EndWrap:
	redraw--;
	if ( ret < 0 ) { ForceDisplay(); return(ret); }
	l = start;
	do {
		Rcleanup(l->next,0);
		l = l->next;
	} while ( l->next != end );
	l = start->next;
	ret = 0;
	do {
		if ( ( start = Radjust(l) ) == 0 ) ret = -1;
		else l = start;
	} while ( ( l = l->next ) != end );
	b->current = end->prev;
	UpdateDisplay();
	ToEOL();
	ForceDisplay();
	return(ret);
}

#endif
 
/*
			#] outline : 
			#[ Wrap Paragraph :

		A paragraph is a contiguous set of lines that contains
		only lines that :
		1 : end with a blank character
		2 : contain characters other than tabs and blanks.
		3 : isn't a foldline.
		The lines that border a paragraph don't fulfil at least
		one of the above conditions.
		The last line of a paragraph may not have the trailing blank.

*/

WORD
NotInParagraph(LINE l)
{
	WORD n;
	UBYTE *s;
	if ( l->used < 0 ) return(-1);	/* Foldline */
	n = l->used - LINEHEAD;
	if ( n <= 0 ) return(-1);		/* No characters */
	s = l->text + n - 1;
	if ( *s-- != ' ' ) return(1);	/* Not ending with a blank */
	n--;
	while ( ( n > 0 ) && ( ( *s == ' ' ) || ( *s == '\t' ) ) ) { s--; n--; }
	if ( n <= 0 ) return(-1);		/* Only tabs and/or blanks */
	return(0);						/* Part of a paragraph */
}

LONG
rewrap(VOID)
{
	BUFFER b = cbuf;
	LINE l;
	WORD ww, oldcolumn;
	LONG number, ret = 0;
	if ( commandmode ) return(0L);
	if ( b->newvirt > 0 ) return(0L);
	if ( b->wordwrap <=0 ) {
		if ( b->wordwrap == 0 ) {
			MesnOut(88); /* "No wordwrap set." */
		}
		else {
			MesnOut(89); /* "No rewrapping in fortran mode." */
		}
		return(0L);
	}
	l = b->current;
	if ( NotInParagraph(l) < 0 ) return(0L);
	ClearUndo();
	number = b->newline;
	do {
		l = l->prev; number--;
	} while ( ( l != (LINE)b ) && !NotInParagraph(l) );
	l = l->next; number++;			/* first line of paragraph */
	b->current = l;
	b->newline = number;
/*
 *	1 : goto end of line; while ( column > wrapcolumn ) wrap
 *	2 : If next line in paragraph -> delete eol, else stop.
 *	3 : goto 1
 */
	ww = b->wordwrap;
	redraw++;
	for(;;) {
		ToEOL(); UpdateDisplay();
		while ( b->column > ww ) {
			oldcolumn = b->column;
			if ( ( ret = WrapWord(b->current,-1) ) < 0 ) goto EndWrap;
			ToEOL(); UpdateDisplay();
			if ( oldcolumn <= b->column ) {
				MesnOut(90); /* "Too long word for autorewrap." */
				goto EndWrap;
			}
		}
		if ( NotInParagraph(l) ) goto EndWrap;
		l = b->current->next;
		ret = 0;
		if ( ( l == (LINE)b ) || ( NotInParagraph(l) < 0 ) || 
			( ( ret = wordel() ) < 0 ) ) goto EndWrap;
	}
EndWrap:
	redraw--;
	ForceDisplay();
	return(ret);
}

/*
			#] Wrap Paragraph : 
 		#] Wordwrapping : 
 		#[ AutoIndent Command :

	Syntax		a+		Autoindent on.
				a#		Fixed indent to column #.
				a#+		Indent to at least column #.
				a-		Autoindent off.
				a		Display current indent mode.

*/

static UBYTE plusplus[] = "+";

LONG
AutoIndent(UBYTE *s,WORD n)
{
	WORD x = 0, i = 0, y;
/*	SKIPBLANKS(s,n); */
	if ( ( n > 0 ) && ( *s == '+' ) ) { s++; x = 1; n--; }
	else if ( ( n > 0 ) && ( *s <= '9' ) && ( *s >= '0' ) ) {
		while ( ( n > 0 ) && ( *s <= '9' ) && ( *s >= '0' ) ) {
			x = x*10 + *s++ - '0'; n--;
		}
		if ( x > 100 ) x = 100;
		x++;					  /* offset to allow the use of x = 1 */
		SKIPBLANKS(s,n);
		if ( ( n > 0 ) && ( *s == '+' ) ) { s++; n--; }
		else x = -x;
	}
	else if ( ( n > 0 ) && ( *s == '-' ) ) { x = 0; s++; n--; }
	else if ( n == 0 ) x = cbuf->autoindent;
	SKIPBLANKS(s,n);
	if ( n > 0 ) return(Syntax());
	cbuf->autoindent = x;
	if ( x == 0 ) {
		MesnOut(91); /* "Autoindent off." */
	}
	else if ( x == 1 ) {
		MesnOut(92); /* "Autoindent on." */
	}
	else {
		if ( x < 0 ) { y = x = -x -1; i = 1; }
		else y = x - 1;
		MesPrint(35,y,plusplus+i); /* "Autoindent at column %d%s" */
	}
	return(0L);
}

/*
 		#] AutoIndent Command : 
 		#[ WordWrap Command :

	Syntax:		w		Display current wordwrap.
				w-		Wordwrap off.
				w#		Wordwrap in column #.
				wf		Wordwrap in fortran mode.
*/

LONG
WordWrap(UBYTE *s,WORD n)
{
	WORD wrap = 0;
/*	SKIPBLANKS(s,n); */
	if ( ( ( n > 0 ) && ( *s == 'f' ) ) || ( *s == 'F' ) ) { wrap = -73; s++; n--; }
	else if ( ( n > 0 ) && ( *s <= '9' ) && ( *s >= '0' ) ) {
		while ( ( n > 0 ) && ( *s <= '9' ) && ( *s >= '0' ) ) {
			wrap = wrap * 10 + *s++ - '0';
			n--;
		}
		if ( wrap < 20 ) wrap = 20;
		wrap++;
	}
	else if ( n == 0 ) wrap = cbuf->wordwrap;
	else if ( ( n > 0 ) && ( *s == '-' ) ) { s++; n--; }
	SKIPBLANKS(s,n);
	if ( n > 0 ) return(Syntax());
	if ( wrap < 0 ) {
		MesnOut(93); /* "Wordwrap in fortran mode." */
	}
	else if ( wrap > 0 ) {
		MesPrint(29,(wrap-1)); /* "Word wrap at column %d" */
	}
	else {
		MesnOut(94); /* "Wordwrap off." */
	}
	cbuf->wordwrap = wrap;
	return(0L);
}

/*
 		#] WordWrap Command : 
  	#] Words : 
*/

