/*
  	#[ Include file :
*/
#include "stedi.h"

extern WORD	Slen;
extern WORD	SDirec;
extern LINE	Sprev;
extern WORD	Scmatch;
extern UBYTE Sstring[];
extern UBYTE *Send;
extern WORD	DispBlock;
extern WORD	Srange;
extern WORD	Sblock;
extern WORD SCase;

/*
  	#] Include file : 
  	#[ Key redefinitions :
*/

LONG
KeyDefRead(UBYTE *s,WORD n)
{
	UBYTE *t, name[128];
#ifdef WITHSWAP
	UBYTE *u, c, c1, c2;
#endif
	LONG len, leng, Lhandle, ret, *stop;
	LONG *k, *KeysIn;
	LONG num, n1, n2;
	WORD handle;
#ifdef WITHSWAP
	WORD swapper = 0;
#endif
	if ( n <= 0 ) return(Syntax());
	if ( *s == '0' ) {
		n--; s++;
		SKIPBLANKS(s,n);
		if ( n > 0 ) return(Syntax());
		if ( dbufFer.redeflength > 0 ) {
			NumberKeys = dbufFer.redeflength = dbufFer.numredef = 0;
			Mfree(KeyPointer);
		}
		return(0L);		
	}
	if ( *s == '\'' || *s == '=' ) { s++; n--; }
	if ( n <= 0 ) return(Syntax());
	t = name;
	while ( --n >= 0 ) *t++ = *s++;
	*t = 0;
	if ( ( Lhandle = MyOpen(name,O_RDONLY) ) < 0 ) {
		MesPrint(9,name); /* "Cannot find file %s" */
		return(-1L);
	}
	handle = (WORD)Lhandle;
	len = FileSeek(0L,handle,2);
	FileSeek(0L,handle,0);
	if ( ( KeysIn = (LONG *)MALLOC((LONG)len) ) == 0 ) {
		MesMem();
		CloseFile(handle);
		return(-1L);
	}
	ret = FileRead(handle,len,(BYTE *)KeysIn);
	CloseFile(handle);
	if ( ret != len ) {
		MesnOut(26); /* "Error while reading." */
		Mfree(KeysIn);
		return(-1L);
	}
	len &= - (LONG)(sizeof(LONG));
	stop = (LONG *)(((UBYTE *)KeysIn) + len);
#ifdef WITHSWAP
  redoKey:
#endif
	num = 0;
	k = KeysIn;
	while ( k < stop ) {
		leng = *k++;
		n1 = *k++;
		k += n1;
		n2 = *k++;
		if ( ( ( ( n1+n2+3 ) *sizeof(LONG) ) != leng ) || ( k > stop ) ) {
#ifdef WITHSWAP
			if ( swapper ) {
#endif
				MesnOut(79); /* "Illegal keyredefinition file." */
				Mfree(KeysIn);
				return(-1L);
#ifdef WITHSWAP
			}
			swapper = 1;
			t = u = (UBYTE *)KeysIn;
			while ( u < (UBYTE *)stop ) {
				c = *u++;
				c1 = *u++;
				c2 = *u++;
				*t++ = *u++;
				*t++ = c2;
				*t++ = c1;
				*t++ = c;
			}
			goto redoKey;
#endif
		}
		k += n2;
		num++;
	}
	NumberKeys = dbufFer.numredef = num;
	dbufFer.redeflength = len;
	Mfree(KeyPointer);
	KeyPointer = KeysIn;
	return(0L);
}

/*
  	#] Key redefinitions : 
  	#[ Execution of external programs :

	Routines for the 'execute an external program' command.
	Syntax :
	!	General execute of the following program + tail.
	!+	With waiting for any key after execution
	!-	Without waiting for any key after execution

*/

LONG
xtern(UBYTE *s,WORD n)
{
	UBYTE TailString[MAXTAIL+2], ProgramString[MAXIPATH];
	UBYTE *end;
	WORD WaitFlag;
	UBYTE *t;
	WORD i;
	LONG ret, time;
	WaitFlag = dbufFer.waitflag;
	if ( n <= 0 ) return(0);
	if ( *s == '+' && n > 0 ) {
		WaitFlag = ON;
		s++; n--;
	}
	else if ( *s == '-' && n > 0 ) {
		WaitFlag = OFF;
		s++; n--;
	}
	t = ProgramString;
	i = 0;
	while ( ( n > 0 ) && ( *s != ' ' ) &&
			( *s != '\t' ) && ( i < MAXIPATH ) )
		{ *t++ = *s++; n--; i++; }
	if ( i == MAXIPATH ) {
		while ( ( n > 0 ) && ( *s != ' ' ) &&
			( *s != '\t' ) ) { s++; n--; }
	}
	*t = '\0';
	end = t - 4;
	s++; n--;		/* Skip one blank or tab */
	if ( n < 0 ) n = 0;
	t = TailString;
	if ( n > MAXTAIL ) n = MAXTAIL;
	*t++ = n;
	while ( n > 0 ) { n--; *t++ = *s++; }
	*t = '\0';
#ifdef UNIX
	PSend();
#else
#ifdef LINUX
	PSend();
#else
	KeyEnd();
#endif
#endif
/*
	End is a pointer to a three character extension. It is meant
	for use in some micro systems that use an MSDOS-like files name
	system (extensions of up to three characters) and a fixed
	extension for some types of programs.
	Time is the time taken for the execution in milliseconds.
*/
	ret = Excute((BYTE *)ProgramString,(BYTE *)TailString,(BYTE *)end,&time);
#ifdef UNIX
	PSbegin();
#else
  #ifdef LINUX
	PSbegin();
  #endif
#endif
	KeyFlush();						/* flush input */
	PSbeep();
	if ( WaitFlag ) KeyChar();		/* Wait for any character */
	if ( dbufFer.color & 1 ) PScolor();
	SetScreen(0);
	UpdateAll();
	time /= 100;
	MesPrint(25,(LONG)(time/10),(WORD)(time%10));
		 /* "Executiontime = %l.%d sec." */
	return(ErrorMes(ret,(WORD)1));
}

/*
  	#] Execution of external programs : 
  	#[ Command line and special characters :
 		#[ iniCommand :
*/

VOID
iniCommand(VOID)
{
	BUFFER b = commandbuffer;
	b->first = b->last = b->current = b->mark = (LINE)b;
	b->column = 1;
	b->offset = 0; b->oldline = b->newline = b->totline = 0;
	b->oldvirt = b->newvirt = 0;
	b->iomode = dbufFer.iomode;
	b->tabstring[0] = 0;
}

/*
 		#] iniCommand : 
 		#[ InsertOne :
*/

LONG
InsertOne(WORD c)
{
	LONG ret;
	WORD y;
	UBYTE cc;
	if ( hexmode ) {
		y = ToUpper[c&0xFF];
		if ( ( y >= '0' && y <= '9' ) || ( y >= 'A' && y <= 'F' ) ) {
			y -= '0';
			if ( y > 9 ) y -= 'A' - '9' - 1;
			if ( hexmode == 1 ) {
				hexmode = 2;
				HexBuffer = c;
				return(0L);
			}
			hexmode = 0;
			c = y;
			y = ToUpper[HexBuffer&0xFF] - '0';
			if ( y > 9 ) y -= 'A' - '9' - 1;
			c += y << 4;
		}
		else ClearHexMode();
	}
	cc = c;
	if ( commandmode ) {
		if ( ( ret = Cinsert(&cc,1) ) < 0 ) return(ret);
		MessageCommand();
		return(0L);
	}
	return(InNorm(&cc,1));
}

/*
 		#] InsertOne : 
 		#[ escape :
*/

LONG
escape(VOID)
{
	BUFFER b = commandbuffer;
	WORD i;
	LINE l;
	LONG ret;
	UBYTE esc = 0x1B;
	if ( !commandmode ) { /* Go to commandmode and start a new line */
		if ( b->totline == 0 ) {	/* first command */
			l = LineAlloc(0,(LINE)b);
			if ( l == (LINE)0 ) return(NOMEMORYL);
			b->totline = 1;
		}
		else {
			if ( b->totline >= 2 && b->first->used == b->first->next->used ) {
				UBYTE *s, *t;
				i = b->first->used - LINEHEAD;
				s = b->first->text;
				t = b->first->next->text;
				while ( --i >= 0 ) {
					if ( *s != *t ) break;
					s++; t++;
				}
				if ( i < 0 ) goto NoNewLine;
			}
			if ( CopyLine(b->first,(LINE)b) < 0 ) {
				/* No memory -> erase history. Use old line. */
				i = (WORD)b->totline - 1;
				while ( --i >= 0 ) LineDealloc(b->last);
				b->totline = 0;
			}
			b->totline++;
NoNewLine:;
		}
		b->column = 1; b->newline = 1;
		if ( b->totline <= 1 ) b->oldline = 1;
		else				   b->oldline = 2;
		b->current = b->first;
		i = dbufFer.maxhist + 1;
		while ( ( b->totline > i ) && ( b->totline > 1 ) ) {
			LineDealloc(b->last);
			b->totline--;
		}
		commandmode = 1;
	}
	else {
			/* 1: Go to Escape mode, 2: get out from it */
		i = 3 - commandmode;
		commandmode = 1;
		if ( ( ret = Cinsert(&esc,1) ) < 0 ) return(ret);
		commandmode = i;
	}
	MessageCommand();
	return(0L);
}

/*
 		#] escape : 
 		#[ newline :
*/

LONG
newline(WORD type)
{
	BUFFER b = commandbuffer;
	LINE l;
	WORD n;
	LONG ret;
	UBYTE ctype = type;
	if ( commandmode ) {
		if ( commandmode > 1 ) {
			commandmode = 1;
			if ( ( ret = Cinsert(&ctype,1) ) < 0 ) return(ret);
			MessageCommand();
			return(0L);
		}
		l = b->current;
		n = l->used - LINEHEAD;
		if ( b->column <= n ) {
			DropPart(l,(WORD)(n-b->column+1));
			n = b->column - 1;
		}
		if ( InMustWrite > 0 ) {
			b->current = l->next;
			l->next->prev = l->prev;
			l->prev->next = l->next;
			b->totline--;
			l->next = 0;
			InMustWrite = 0;
		}
		MessageCommand();
		return(DoCommand(l,(LINE)b));
	}
	return(CRnorm());
}

/*
 		#] newline : 
 		#[ backspace :
*/

LONG
backspace(VOID)
{
	LONG ret;
	UBYTE bs = 8;
	if ( commandmode ) {
		if ( commandmode > 1 ) {
			commandmode = 1;
			if ( ( ret = Cinsert(&bs,1) ) < 0 ) return(ret);
		}
		else if ( commandbuffer->column > MinCommandColumn ) {
			commandbuffer->column--;
			if ( ( ret = Tdelete() ) < 0 ) {
				commandbuffer->column++;
				return(ret);
			}
		}
		MessageCommand();
		return(0L);
	}
	return(Bdelete());
}

/*
 		#] backspace : 
 		#[ delete :
*/

LONG
delete(VOID)
{
	LONG ret;
	UBYTE bs = 0x7F;
	if ( commandmode ) {
		if ( commandmode > 1 ) {
			commandmode = 1;
			if ( ( ret = Cinsert(&bs,1) ) < 0 ) return(ret);
		}
		else if ( ( ret = Tdelete() ) < 0 ) return(ret);
		MessageCommand();
		return(0L);
	}
	return(Cdelete());
}

/*
 		#] delete : 
  	#] Command line and special characters : 
  	#[ Pause :

	Wait a given number of deciseconds.
*/

LONG
Pause(UBYTE *s,WORD n)
{
	LONG x;
	NumVal(s,(LONG)n,&x);
	if ( !commandmode ) TextCursor();
	if ( !redraw ) CursorOn();
	MyWait(GetTicks() + x*100);
	if ( !redraw ) CursorOff();
	return(0);
}

/*
  	#] Pause : 
  	#[ Yank :

	This is the internal version of the old del macro.
	Syntax: del string
	It will delete all lines which contain string
	If the string starts with a / we will use regular expressions.
	If the string ends with a / followed by options these will be options
	used in the search.
	In the case the string contains linefeeds the delete is from the 
	beginning of the first line of the pattern to the end of its last line.

	This and the Get routine are the first additions in more than 15 years.
	Jos Vermaseren -feb-2006
*/

#define NEWVERSION

LONG
Yank(UBYTE *s,WORD n)
{
#ifdef NEWVERSION
	BUFFER b = cbuf;
	UBYTE *r, *Slastchar = 0;
	LONG retval = 0;
	LINE dummyline, Slast = 0;
	WORD rh, isregexp = 0;
/*
	First test the syntax.
*/
	if ( n > 1 && ToUpper[s[0]] == 'A' ) {
		n--; s++;
		if ( n > 1 && ToUpper[s[0]] == 'N' ) {
			n--; s++;
			if ( n > 1 && ToUpper[s[0]] == 'K' ) {
				n--; s++;
			}
		}
	}
	SKIPTBLANKS(s,n);
	if ( n < 2 || s[0] != '/' ) {
		MesnOut(117);  /* Syntax error in Yank command */
		return(-1);
	}
	s++; n--;
	IniSearch();

	if ( *s == '/' ) {
		s++; n--;
		if ( n <= 0 ) return(0);
		if ( ( retval = RegExp(s,n,1) ) < 0 ) {
			if ( retval == -2 ) {
				MesOut("No substitutions allowed in Yank command");
			}
			return(-1);
		}
		DispBlock = 1;
		isregexp = 1;
	}
	else {
/*
		We initiate the search operation only once.
*/
		DispBlock = 1;
		r = (UBYTE *)Sstring;
		do {
			if ( *s == 0x1B ) { /* <Escape> */
				s++; n--;
				if ( n <= 0 ) return(Syntax());
				if ( ( rh = ReadHex( (WORD)(*s), (WORD)(*(s+1)) ) ) >= 0 )
					{ *r++ = rh; s += 2; n--; }
				else {
					*r++ = *s++;
				}
			}
			else { *r++ = *s++; }
			n--;
		} while ( ( n > 0 ) && ( *s != '/' ) );
		Slen = (WORD)(r - Sstring);
		Send = r;
		if ( ( n > 0 ) && ( *s == '/' ) ) {
			s++; n--;
			SKIPTBLANKS(s,n);
		}
		if ( ( n > 0 ) && ( *s == '=' ) ) {
			DispBlock = 0;
			MesOut("Replacement not allowed in Yank command");
			return(-1);
		}
		DoOptions(s,n);
		SDirec = 1;
		Srange = 0;
		Sblock = 0;
/*
		Make the Boyer and Moore table once for the complete action.
*/
		MakeTable();
		if ( SCase == 0 ) {	/* Case insensitive search */
			int i;
			for ( i = 0; i < Slen; i++ ) Sstring[i] = ToUpper[Sstring[i]];
		}
	}
/*
	Action 1: Clear the Undo buffer and the mark.
	Insert an empty line. Go to the home position.
*/
	ClearUndo();
	b->mark = (LINE)b;
	b->MarkVirt = b->MarkVoff = b->MarkChar = b->MarkColumn = 0;
	if ( b->first == (LINE)b ) return(0);
	if ( ( dummyline = LineAlloc(0,(LINE)b) ) == 0 ) return(NOMEMORYL);
	b->current = b->first;
	b->newline = b->oldline = 1; b->column = 1;
	b->oldvirt = b->newvirt = 0;

	for (;;) {
		if ( isregexp ) {
			if ( ( retval = RegExp(s,n,2) ) <= 0 ) break;
			retval = 0;
			Slast = RegGetEnd(&Slastchar);
		}
		else {
/* 
			Determine the bounds
*/
			if ( DetBounds(0) < 0 ) { retval = -1; break; }
/*
			Now conduct a forward search
*/
			if ( forward() <= 0 ) break;
			Slast = Sprev;
		}

		b->current = Sprev;
		b->newvirt = 0;
/*
		Now the delete. For simple searches (no \n included) we can be done fast
*/
		b->column = 1;
		b->current = b->current->prev;
		while ( b->current->next != Slast ) LineDealloc(b->current->next);
		if ( Slast != (LINE) b ) LineDealloc(Slast);
		b->dirtyflag = 1;
		if ( b->current->next == (LINE)b ) break;
		ToEOL();
	}
/*
	Remove the empty line if still there.
	Go to the home position (and clean up)
*/
	if ( b->first == dummyline ) { LineDealloc(dummyline); }
	clrhom();
	return(retval);
#else
	MesOut("Yank command not yet implemented");
	return(0);
#endif
}

/*
  	#] Yank : 
  	#[ Get :

	This is the internal version of the old sel macro.
	It was rather slow on large files.
	Also it could not use regular expressions due to the backward search.
	Syntax: sel string
	It will select all lines which contain string
	If the string starts with a / we will use regular expressions.
	If the string ends with a / followed by options these will be options
	used in the search.
	In the case the string contains linefeeds the selection is from the 
	beginning of the first line of the pattern to the end of its last line.
*/

LONG
Get(UBYTE *s,WORD n)
{
#ifdef NEWVERSION
/*
	First test the syntax.
*/
	BUFFER b = cbuf;
	UBYTE *r, *Slastchar = 0;
	LONG retval = 0;
	LINE dummyline, vmark, Slast = 0;
	WORD rh, action = 0, isregexp = 0;

	if ( n > 1 && ToUpper[s[0]] == 'E' ) {
		n--; s++;
		if ( n > 1 && ToUpper[s[0]] == 'T' ) {
			n--; s++;
		}
	}
	SKIPTBLANKS(s,n);
	if ( n < 2 || s[0] != '/' ) {
		MesnOut(116);  /* Syntax error in Get command */
		return(-1);
	}
	s++; n--;
	IniSearch();

	if ( *s == '/' ) {
		s++; n--;
		if ( n <= 0 ) return(0);
		if ( ( retval = RegExp(s,n,1) ) < 0 ) {
			if ( retval == -2 ) {
				MesOut("No substitutions allowed in Get command");
			}
			return(-1);
		}
		DispBlock = 1;
		isregexp = 1;
	}
	else {
/*
		We initiate the search operation only once.
*/
		DispBlock = 1;
		r = (UBYTE *)Sstring;
		do {
			if ( *s == 0x1B ) { /* <Escape> */
				s++; n--;
				if ( n <= 0 ) return(Syntax());
				if ( ( rh = ReadHex( (WORD)(*s), (WORD)(*(s+1)) ) ) >= 0 )
					{ *r++ = rh; s += 2; n--; }
				else {
					*r++ = *s++;
				}
			}
			else { *r++ = *s++; }
			n--;
		} while ( ( n > 0 ) && ( *s != '/' ) );
		Slen = (WORD)(r - Sstring);
		Send = r;
		if ( ( n > 0 ) && ( *s == '/' ) ) {
			s++; n--;
			SKIPTBLANKS(s,n);
		}
		if ( ( n > 0 ) && ( *s == '=' ) ) {
			DispBlock = 0;
			MesOut("Replacement not allowed in Get command");
			return(-1);
		}
		DoOptions(s,n);
		SDirec = 1;
		Srange = 0;
		Sblock = 0;
/*
		Make the Boyer and Moore table once for the complete action.
*/
		MakeTable();
		if ( SCase == 0 ) {	/* Case insensitive search */
			int i;
			for ( i = 0; i < Slen; i++ ) Sstring[i] = ToUpper[Sstring[i]];
		}
	}
/*
	Action 1: Clear the Undo buffer and the mark.
	Insert an empty line. Go to the home position.
*/
	ClearUndo();
	b->mark = (LINE)b;
	b->MarkVirt = b->MarkVoff = b->MarkChar = b->MarkColumn = 0;
	if ( b->first == (LINE)b ) return(0);
	if ( ( dummyline = LineAlloc(0,(LINE)b) ) == 0 ) return(NOMEMORYL);
	b->current = b->first;
	b->newline = b->oldline = 1; b->column = 1;
	b->oldvirt = b->newvirt = 0;
/*
	Set the mark. We need it for deleting a range.
	Position the cursor at the end of the previous line.
*/
	b->current = b->current->next;
	sl_arr();
	setmrk();
	b->current = b->current->prev;
	ToEOL();

	for (;;) {
		if ( isregexp ) {
			if ( ( retval = RegExp(s,n,2) ) <= 0 ) {
				if ( retval == 0 && action ) {
					vmark = b->mark->prev;
					b->mark = (LINE)b;
					b->MarkVirt = b->MarkVoff = b->MarkChar = b->MarkColumn = 0;
					while ( vmark->next != (LINE)b ) Discard(vmark->next);
				}
				break;
			}
			retval = 0;
			Slast = RegGetEnd(&Slastchar);
		}
		else {
/* 
			Determine the bounds
*/
			if ( DetBounds(0) < 0 ) { retval = -1; break; }
/*
			Now conduct a forward search
*/
			if ( forward() <= 0 ) {
/*
				If there was no action at all, we don't do anything
				Otherwise we delete lines to the end of the file.
*/
				if ( action ) {
					vmark = b->mark->prev;
					b->mark = (LINE)b;
					b->MarkVirt = b->MarkVoff = b->MarkChar = b->MarkColumn = 0;
					while ( vmark->next != (LINE)b ) Discard(vmark->next);
				}
				break;
			}
			Slast = Sprev;
		}
		b->current = Sprev;
		b->newvirt = 0;
/*
		Now the delete.
*/
		if ( b->current->next == b->mark ) {
		}
		else if ( b->current == b->mark ) {
			b->mark = (LINE)b;
			b->MarkVirt = b->MarkVoff = b->MarkChar = b->MarkColumn = 0;
		}
		else {
			vmark = b->mark->prev;
			b->mark = (LINE)b;
			b->MarkVirt = b->MarkVoff = b->MarkChar = b->MarkColumn = 0;
			while ( vmark->next != b->current ) Discard(vmark->next);
			action = 1;
		}
		b->current = Slast;
/*
		Now set the position correctly at the last character of the match.
*/
		if ( isregexp ) {
			b->current = b->current->next;
			sl_arr();
			setmrk();
			b->current = b->current->prev;
			b->column  = FindColumn(Slast,(WORD)(Slastchar-Slast->text));
			b->newvirt = 0;
		}
		else {
			b->current = b->current->next;
			sl_arr();
			setmrk();
			b->current = b->current->prev;
			ToEOL();
		}
	}
/*
	Remove the empty line if still there.
	Go to the home position (and clean up)
*/
	if ( b->first == dummyline ) { LineDealloc(dummyline); }
	if ( action ) b->dirtyflag = 1;
	clrhom();
	return(retval);
#else
	MesOut("Get command not yet implemented");
	return(0);
#endif
}

/*
  	#] Get : 
*/

